
%if 0%{?gitver:1}
  %global srcurl   https://github.com/NeoRaider/%{name}/archive/%{gitver}.tar.gz#/%{name}-%{gitver}.tar.gz
  %global setuppath %{name}-%{gitver}
%else
  %global srcurl   https://github.com/NeoRaider/%{name}/archive/v%{version}.tar.gz#/%{name}-%{version}.tar.gz
  %global setuppath %{name}-%{version}
%endif


Name:           fastd
Version:        22
Release:    1%{?dist}
Summary:        Fast and secure tunneling daemon

License:        BSD
URL:            https://github.com/NeoRaider/fastd/wiki
Source0:        %{srcurl}

BuildRequires:  gcc
BuildRequires:  meson
BuildRequires:  python3-sphinx

BuildRequires:  bison
BuildRequires:  json-c-devel
BuildRequires:  libcap-devel
BuildRequires:  libmnl-devel
BuildRequires:  libsodium-devel
BuildRequires:  libuecc-devel
BuildRequires:  openssl-devel
BuildRequires:  systemd

Requires(post):   systemd
Requires(preun):  systemd
Requires(postun): systemd

Recommends:     kmod(l2tp_core.ko)
Recommends:     kmod(l2tp_eth.ko)
Recommends:     kmod(l2tp_netlink.ko)
Suggests:       kernel-modules

%description
fastd is a secure tunneling daemon with some unique features:

 - Very small binary (about 100KB on OpenWRT in the default configuration,
   including all dependencies besides libc)
 - Exchangable crypto methods
 - Transport over UDP for simple usage behind NAT
 - Can run in 1:1 and 1:n scenarios
 - There are no server and client roles defined by the protocol, this is just
   defined by the usage.
 - Only one instance of the daemon is needed on each host to create a full mesh
   If no full mesh is established, a routing protocol is necessary to enable
   hosts that are not connected directly to reach each other

%prep
%autosetup -p1 -n %{setuppath}


%build
%ifnarch %{ix86} x86_64
  %meson \
    -Dcipher_salsa2012_xmm=disabled \
    -Dmac_ghash_pclmulqdq=disabled \
    -Dcipher_salsa20_xmm=disabled
%else
  %meson
%endif

%meson_build

pushd doc
  make text
popd

%install
%meson_install

install -Dpm 0644 doc/examples/fastd@.service %{buildroot}/%{_unitdir}/%{name}@.service
install -Dpm 0644 doc/fastd.1 %{buildroot}/%{_mandir}/man1/%{name}.1
install -d %{buildroot}/%{_sysconfdir}/%{name}


%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service


%files
%doc README.md doc/build/text/*
%license COPYRIGHT
%dir %{_sysconfdir}/%{name}
%{_mandir}/man1/%{name}.1.gz
%{_unitdir}/%{name}@.service
%{_bindir}/%{name}


%changelog
* Fri Apr 12 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 22-1
- initial build
